<?php

/*
 * RekmixaCMS - The Newest Multifunctional Content Management System
 * Author - rekmixa
 * E-mail - rekmixa@gmail.com
 * Site - http://wordads.ru
 */

require_once("inc/head.php");

if ($count_news > 0) {

    $sql = $connect->query("select * from `news` order by `id` desc limit 1");

    foreach ($sql as $row) {

        $text = mb_strlen($row['text']) > $sys['system']['news_s'] ? mb_substr($row['text'], 0, $sys['system']['news_s']).'...' : $row['text'];

        echo '<div class="title">'.$row['name'].'</div>
        <div class="menu">
        '.nl2br(smiles(bb(bbyoutube(bblinks($text))))).'
        <div class="butt3"><a href="/news/event/'.$row['id'].'">Подробнее</a></div>
        </div>';

    }

}

if (isset($active)) {

    echo '<div class="title">Кабинет<span class="count">'.profileLink($user['id']).'</span></div>';

    switch ($act) {

        case 'success':

            echo '<div class="menu"><div class="good">Операция прошла успешно!</div></div>';

            break;

        case 'fail':

            echo '<div class="menu"><div class="forbidden">Произошла ошибка!</div></div>';

    }

    echo '<div class="menu">';

    if (empty($user['wmr'])) {

        echo '<div class="dash">';

        if (isset($_POST['wmr'])) {

            // Поиск wmr в базе
            $wmr_s = $connect->prepare("select count(*) from `users` where `wmr` = ?");
            $wmr_s->execute(array($_POST['wmr']));

            $error = '';

            if (empty($_POST['wmr'])) {
                $error.= 'Введите ваш кошелек!<br/>';
            }
            elseif (!preg_match("#^R[0-9]{12}$#i", $_POST['wmr'])) {
                $error.= 'Неверно введен WMR-кошелек: вводить нужно, начиная с R!<br/>';
            }
            elseif ($wmr_s->fetchColumn()) {
                $error.= 'Пользователь с таким кошельком уже зарегистрирован!<br/>';
            }
            if ($error) {
                echo '<div class="red">'.$error.'</div>';
            } else {
                $stmt = $connect->prepare("update `users` set `wmr` = ? where `id` = ?");
                if ($stmt->execute(array($_POST['wmr'], $user['id']))) {
                    header('Location: /');
                } else {
                    echo '<div class="menu">Произошла ошибка!</div>';
                }
            }
        }

        echo '<form action="" method="POST">
        WMR-кошелек:<br/><input type="text" name="wmr" value="R" maxlength="13"><br/>
        <input type="submit" value="Заполнить">
        </form></div>';

    } else {

        if ($user['wmid'])
            echo 'WMID: '.$user['wmid'].'<br/>';

        echo 'Кошелек: <img src="/img/wmr.png" alt="wmr">'.$user['wmr'].'<br/>';

    }

    echo 'Баланс: '.quantDec($user['money'], ['рубль', 'рубля', 'рублей']).'<br/>
    E-mail: '.$user['email'].'<br/>
    Рейтинг: '.rankUser($user['rating']).'
    </div>
    <div class="forlink"><a href="/plus" class="links"><img src="/img/money.png" alt="money">Пополнить баланс</a></div>
    <div class="forlink"><a href="/minus" class="links"><img src="/img/moneyback.png" alt="moneyback">Вывод средств</a></div>';

} else {

    if (isset($_GET['ref']) && user($_GET['ref']))
        $_SESSION['ref'] = intval($_GET['ref']);

    echo '<div class="title">Авторизация</div>';

    if (isset($_POST['auth'])) {

        $user = user($_POST['login'], 1);

        $error = '';

        if (isset($_SESSION['captcha_auth']) && empty($_POST['code'])) {
            $error.= 'Введите код с картинки!<br/>';
        }
        elseif (isset($_SESSION['captcha_auth']) && $_SESSION['code'] != $_POST['code']) {
            $error.= 'Код с картинки введен неверно!<br/>';
        }
        elseif (empty($_POST['login'])) {
            $error.= 'Введите логин!<br/>';
        }
        elseif (!$user) {
            $error.= 'Пользователь с данным логином не зарегистрирован!<br/>';
        }
        elseif ($user['ban'] > time()) {
            $error.= 'Этот аккаунт заблокирован!<br/>';
        }
        elseif (empty($_POST['pass'])) {
            $error.= 'Введите пароль!<br/>';
        }
        elseif (!password_verify($_POST['pass'], $user['pass'])) {
            $_SESSION['captcha_auth'] = 1; // включаем капчу
            $error.= 'Неверный пароль!<br/>';
        }
        if ($error) {
            echo '<div class="menu">'.$error.'</div>';
        } else {

            if ($authlog->execute(array(time(), $user['id'], $ip, $ua))) {

                $authid = $connect->LastInsertId();

                $expire = isset($_POST['save']) ? time() + 3600 * 24 * 365 : 0;

                // авторизация
                setcookie('user_id', $user['id']);
                setcookie('user_id', $user['id'], $expire, '/');
                setcookie('pass', $user['pass']);
                setcookie('pass', $user['pass'], $expire, '/');
                setcookie('auth', $authid);
                setcookie('auth', $authid, $expire, '/');

                header('Location: /');

            } else {
                echo '<div class="menu">Произошла ошибка!</div>';
            }
        }
    }

    echo '<div class="menu">
    <form name="auth" action="" method="POST">
    Логин:<br/><input type="text" name="login"><br/>
    Пароль:<br/><input type="password" name="pass"><br/>
    '.(isset($_SESSION['captcha_auth']) ? 'Код с картинки:<img id="captcha" src="/img/code.php" alt="check" onClick="UpCaptcha()"><br/>
    <input type="text" name="code"><br/>' : '').'
    <input type="submit" name="auth" value="Войти">
    <input type="checkbox" name="save" value="1">Запомнить
    </form></div>
    <div class="forlink"><a href="/reg" class="links"><img src="/img/reg.png" alt="reg">Зарегистрироваться</a></div>
    <div class="forlink"><a href="/forgot" class="links"><img src="/img/help.png" alt="help">Забыли пароль?</a></div>';

}

/* Меню сайта и Feed-block (для мобилок) */

echo '<div class="visible-xs">';

    include("inc/menu.php");

    include("inc/feed-block.php");

echo '</div>';

require("inc/foot.php");
?>