<?php

/*
 * RekmixaCMS - The Newest Multifunctional Content Management System
 * Author - rekmixa
 * E-mail - rekmixa@gmail.com
 * Site - http://wordads.ru
 */

require($_SERVER["DOCUMENT_ROOT"]."/inc/checker.php");

ob_start();

/* Настройки */

$old = parse_ini_file($_SERVER["DOCUMENT_ROOT"]."/inc/system.ini", true);

$sys = parse_ini_file("system.ini", true);

// Подключение к БД
try {
    $connect = new PDO('mysql:host=' . $old['db']['db_host'] . ';dbname=' . $old['db']['db_name'] . ';charset=utf8', $old['db']['db_user'], $old['db']['db_pass']);
} catch (PDOException $e) {
    exit('Подключение не удалось: ' . $e->getMessage());
}

/* Установка */

session_name('SID') . session_start();

require_once($_SERVER["DOCUMENT_ROOT"]."/inc/file_function.php");

?>
<!DOCTYPE html PUBLIC "-//WAPFORUM//DTD XHTML Mobile 1.0//EN" "http://www.wapforum.org/DTD/xhtml-mobile10.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<link rel="shortcut icon" href="/favicon.ico"/>
<title>Обновление RCMS</title>
<link rel="stylesheet" href="/style/bootstrap/css/bootstrap.min.css" type="text/css"/>
<link rel="stylesheet" href="/style/default.css" type="text/css"/> 
<script type="text/javascript" src="/js/jquery-3.2.1.min.js"></script>
<script type="text/javascript" src="/style/bootstrap/js/bootstrap.min.js"></script>
<script type="text/javascript" src="/js/function.js"></script>
</head>
<body>
<div class="nav-pos">
<div class="logo"><img src="/img/logo.png" alt="logo"></div>
</div>
<div class="content">
<div class="center-block">
<?

if (isset($_POST['update'])) {

    /* Перенос настроек */

    foreach ($sys as $selector => $configs) {

        foreach ($configs as $key => $value) {

            if (isset($old[$selector][$key]))
                $sys[$selector][$key] = $old[$selector][$key];

        }

    }

    // CHMOD
    chmod($_SERVER["DOCUMENT_ROOT"]."/inc/foot.php", 0666);
    chmod("system.ini", 0666);

    // Сохранение настроек
    write_ini_file("system.ini", $sys);

    // Переносим файл настроек в папку inc
    rename("system.ini", $_SERVER["DOCUMENT_ROOT"]."/inc/system.ini");

    /* Обновление БД */

    function user($user, $type = 0) {

        global $connect;

        if ($type == 1) {

            $sql = "select * from `users` where `login` = ?";

        } else {

            $sql = "select * from `users` where `id` = ?";

        }

        $result = $connect->prepare($sql);
        $result->execute(array($user));
        $info = $result->fetch(PDO::FETCH_LAZY);

        return $info;

    }

    $connect->exec("alter table `authlog` add `uid` bigint(20) UNSIGNED NOT NULL");
    $connect->exec("alter table `authlog` drop `user`");
    $connect->exec("delete from `authlog`");

    $connect->exec("alter table `speedpass` add `uid` bigint(20) UNSIGNED NOT NULL");
    $connect->exec("alter table `speedpass` drop `user`");
    $connect->exec("delete from `speedpass`");

    $connect->exec("alter table `rek` add `comment` varchar(500) NOT NULL");
    $connect->exec("alter table `rek` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `rek` set `uid` = ? where `id` = ?");

    $sql = $connect->query("select * from `rek`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `rek` drop `user`");

    $connect->exec("alter table `respect` modify `from` bigint(20) UNSIGNED NOT NULL");
    $connect->exec("alter table `respect` modify `to` bigint(20) UNSIGNED NOT NULL");
    $connect->exec("delete from `respect`");

    $connect->exec("alter table `friend` add `from` bigint(20) UNSIGNED NOT NULL");
    $connect->exec("alter table `friend` add `to` bigint(20) UNSIGNED NOT NULL");
    $connect->exec("alter table `friend` drop `user_from`");
    $connect->exec("alter table `friend` drop `user_to`");
    $connect->exec("delete from `friend`");

    $connect->exec("alter table `blacklist` add `uid` bigint(20) UNSIGNED NOT NULL");
    $connect->exec("alter table `blacklist` modify `black` bigint(20) UNSIGNED NOT NULL");
    $connect->exec("alter table `blacklist` drop `user`");
    $connect->exec("delete from `blacklist`");

    $connect->exec("alter table `shop` add `tags` text NOT NULL");
    $connect->exec("alter table `shop` add `seller` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `shop` set `seller` = ? where `id` = ?");

    $sql = $connect->query("select * from `shop`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `shop` drop `user`");

    $connect->exec("alter table `purchase` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `purchase` set `uid` = ?, `seller` = ? where `id` = ?");

    $sql = $connect->query("select * from `purchase`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);
        $seller = user($row['seller'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $seller['id'], $row['id']));

        }

    }

    $connect->exec("alter table `purchase` modify `seller` bigint(20) UNSIGNED NOT NULL");
    $connect->exec("alter table `purchase` drop `user`");

    $connect->exec("CREATE TABLE IF NOT EXISTS `discounts` (
      `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
      `uid` bigint(20) UNSIGNED NOT NULL,
      `sum` float(11,2) NOT NULL,
      `pid` bigint(20) UNSIGNED NOT NULL,
      PRIMARY KEY (`id`)
    ) ENGINE=MyISAM DEFAULT CHARSET=utf8");

    $connect->exec("alter table `basket` add `uid` bigint(20) UNSIGNED NOT NULL");
    $connect->exec("alter table `basket` drop `user`");
    $connect->exec("delete from `basket`");

    $connect->exec("alter table `task` add `memory` int(11) NOT NULL");
    $connect->exec("alter table `task` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `task` set `uid` = ? where `id` = ?");

    $sql = $connect->query("select * from `task`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `task` drop `user`");

    $connect->exec("alter table `task_ans` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `task_ans` set `uid` = ? where `id` = ?");

    $sql = $connect->query("select * from `task_ans`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `task_ans` drop `user`");

    $connect->exec("alter table `link` add `status` tinyint(3) NOT NULL");
    $connect->exec("alter table `link` add `memory` int(11) NOT NULL");
    $connect->exec("alter table `link` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `link` set `uid` = ?, `status` = '1' where `id` = ?");

    $sql = $connect->query("select * from `link`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `link` drop `user`");
    $connect->exec("alter table `link` drop `off`");

    $connect->exec("alter table `click` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `click` set `uid` = ? where `id` = ?");

    $sql = $connect->query("select * from `click`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `click` drop `user`");

    $connect->exec("CREATE TABLE IF NOT EXISTS `forbid_browser` (
      `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
      `link` bigint(20) UNSIGNED NOT NULL,
      `browser` varchar(250) NOT NULL,
      PRIMARY KEY (`id`)
    ) ENGINE=MyISAM DEFAULT CHARSET=utf8");

    $connect->exec("alter table `loto` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `loto` set `uid` = ? where `id` = ?");

    $sql = $connect->query("select * from `loto`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `loto` drop `user`");

    $connect->exec("alter table `win_loto` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `win_loto` set `uid` = ? where `id` = ?");

    $sql = $connect->query("select * from `win_loto`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `win_loto` drop `user`");

    $connect->exec("alter table `num` add `num` tinyint(3) NOT NULL");
    $connect->exec("alter table `num` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `num` set `uid` = ? where `id` = ?");

    $sql = $connect->query("select * from `num`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `num` drop `user`");

    $connect->exec("alter table `prmd` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `prmd` set `uid` = ? where `id` = ?");

    $sql = $connect->query("select * from `prmd`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `prmd` drop `user`");

    $connect->exec("alter table `win_prmd` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `win_prmd` set `uid` = ? where `id` = ?");

    $sql = $connect->query("select * from `win_prmd`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `win_prmd` drop `user`");

    $connect->exec("alter table `news` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `news` set `uid` = ? where `id` = ?");

    $sql = $connect->query("select * from `news`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `news` drop `user`");

    $connect->exec("alter table `topic` add `top` bigint(11) NOT NULL");
    $connect->exec("alter table `topic` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `topic` set `uid` = ? where `id` = ?");

    $sql = $connect->query("select * from `topic`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `topic` drop `user`");

    $connect->exec("alter table `comments` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `comments` set `uid` = ? where `id` = ?");

    $sql = $connect->query("select * from `comments`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `comments` drop `user`");

    $connect->exec("alter table `guest` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `guest` set `uid` = ? where `id` = ?");

    $sql = $connect->query("select * from `guest`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `guest` drop `user`");

    $connect->exec("alter table `contacts` add `from` bigint(20) UNSIGNED NOT NULL");
    $connect->exec("alter table `contacts` add `to` bigint(20) UNSIGNED NOT NULL");
    $connect->exec("alter table `contacts` drop `user_from`");
    $connect->exec("alter table `contacts` drop `user_to`");
    $connect->exec("delete from `contacts`");

    $connect->exec("alter table `mail` add `from` bigint(20) UNSIGNED NOT NULL");
    $connect->exec("alter table `mail` add `to` bigint(20) UNSIGNED NOT NULL");
    $connect->exec("alter table `mail` drop `user`");
    $connect->exec("alter table `mail` drop `who`");
    $connect->exec("delete from `mail`");

    $connect->exec("alter table `payment` add `uid` bigint(20) UNSIGNED NOT NULL");

    $stmt = $connect->prepare("update `payment` set `uid` = ? where `id` = ?");

    $sql = $connect->query("select * from `payment`");

    foreach ($sql as $row) {

        $user = user($row['user'], 1);

        if ($user) {

            $stmt->execute(array($user['id'], $row['id']));

        }

    }

    $connect->exec("alter table `payment` drop `user`");

    $connect->exec("alter table `users` add `where` varchar(250) NOT NULL");
    $connect->exec("alter table `users` add `wid` bigint(20) NOT NULL");
    $connect->exec("alter table `users` add `timezone` varchar(99) NOT NULL");
    $connect->exec("alter table `users` add `birth` varchar(50) NOT NULL");
    $connect->exec("alter table `users` add `hd` tinyint(3) NOT NULL DEFAULT '1'");
    $connect->exec("alter table `users` add `wmid` varchar(15) NOT NULL");
    $connect->exec("alter table `users` add `adm_pos` varchar(150) NOT NULL");
    $connect->exec("alter table `users` modify `ban` bigint(11) NOT NULL");
    $connect->exec("alter table `users` drop `avatar`");
    $connect->exec("alter table `users` drop `icon`");

    /* Завершение */

    // Удаляем папку install
    delete_dir(__DIR__);

    header('Location: /');

}

?>
<div class="title">Обновление RCMS</div>
<div class="menu">
<form method="POST">
<div class="information">При обновлении все ваши данные и настройки сохранятся!</div>
<input type="submit" name="update" value="Продолжить">
</form></div>
</div></div>
<div class="ze"><?=date('H:i:s');?></div>
</body>
</html>
<? ob_end_flush(); ?>