<?php
$title = 'Новость';
require_once($_SERVER["DOCUMENT_ROOT"]."/inc/head.php");

$strow_event = $connect->prepare("select * from `news` where `id` = ?");
$strow_event->execute(array($id));
$n_row = $strow_event->fetch(PDO::FETCH_LAZY);

if ($n_row) {

    // тип
    $type = 1;
    // количество комментариев
    $stmt_comm->execute(array($id, $type));
    $count_comm = $stmt_comm->fetchColumn(); 

    echo '<div class="title">'.$n_row['name'].'</div>';

    if ($adm_id == 1 || $adm_id == 2 || $adm_id == 5) {
        if (isset($_GET['del_n'])) {
            if (isset($_POST['ok'])) {
                $del = $connect->prepare("delete from `news` where `id` = ?");
                $del_comm = $connect->prepare("delete from `comments` where `did` = ? and `type` = ?"); 
                if ($del->execute(array($id)) && $del_comm->execute(array($id, $type))) { 
                    header ('location: /news');
                } else {
                    echo '<div class="menu">Произошла ошибка!</div>';
                }
            }
            elseif (isset($_POST['cancel'])) {
                header('Location: /news/event/'.$id);
            }
            echo '<div class="menu">
            <form action="" method="POST">
            <input type="submit" name="ok" value="Удалить">
            <input type="submit" name="cancel" value="Отмена">
            </form></div>';
        }
        elseif (isset($_GET['edit_n'])) {
            if (isset($_POST['cancel'])) {
                header('Location: /news/event/'.$id);
            }
            elseif (isset($_POST['red'])) {
                $error = '';
                if (empty($_POST['name'])) {
                    $error.= 'Введите заголовок новости!<br/>';
                }
                elseif (mb_strlen($_POST['name']) < 5 || mb_strlen($_POST['name']) > 50) {
                    $error.= 'Заголовок новости должен содержать не менее 5 и не более 50 символов!<br/>';
                }
                if (empty($_POST['text'])) {
                    $error.= 'Введите текст новости!<br/>';
                }
                elseif (mb_strlen($_POST['text']) < 10 || mb_strlen($_POST['text']) > 5000) {
                    $error.= 'Текст новости должен содержать не менее 10 и не более 5000 символов!<br/>';
                } 
                if ($error) {
                    echo '<div class="menu">'.$error.'</div>';
                } else {
                    $stmt = $connect->prepare("update `news` set `name` = ?, `text` = ? where `id` = ?");
                    if ($stmt->execute(array($_POST['name'], $_POST['text'], $id))) {
                        header('Location: /news/event/'.$id);
                    } else {
                        echo '<div class="menu">Произошла ошибка!</div>';
                    }
                }
            }
            echo '<div class="menu">
            <form action="" method="POST">
            Тема:<br/><input type="text" name="name" value="'.$n_row['name'].'"><br/>
            Текст:<br/><textarea name="text" rows="5" cols="25">'.$n_row['text'].'</textarea><br/>
            <input type="submit" name="red" value="Сохранить">
            <input type="submit" name="cancel" value="Отмена">
            </form></div>';
        }
    }

    echo '<div class="menu">
    '.nl2br(smiles(bb(bbyoutube(bblinks($n_row['text']))))).'<hr/>
    Опубликовал: '.profileLink($n_row['uid']).'<br/>
    Дата публикации: '.daytime($n_row['time']).
    (($adm_id == 1 || $adm_id == 2 || $adm_id == 5) ? '<div class="butt2"><a href="?del_n">Удалить</a><a href="?edit_n">Редактировать</a></div>' : '').'
    </div>';

    // prepared
    $stmt_num = $connect->prepare("select count(*) from `comments` where `id` = ? and `type` = ? and `did` = ?");
    $strow = $connect->prepare("select * from `comments` where `id` = ?");

    echo '<div class="title">Комментарии ('.$count_comm.')</div>';

    if (isset($active)) {

        include($_SERVER["DOCUMENT_ROOT"]."/inc/smiles_bb.php");

        if (isset($_GET['edit'])) {
            $stmt_num_edit = $connect->prepare("select count(*) from `comments` where `date` > ? and `uid` = ? and `id` = ? and `type` = ? and `did` = ?");
            $stmt_num_edit->execute(array(time() - 60, $user['id'], $_GET['edit'], $type, $id));
            if ($stmt_num_edit->fetchColumn()) {
                $strow->execute(array($_GET['edit']));
                $row = $strow->fetch(PDO::FETCH_LAZY);
                if (isset($_POST['yes'])) {
                    $error = '';
                    if (empty($_POST['text'])) {
                        $error.= 'Введите сообщение!<br/>';
                    }
                    elseif (mb_strlen($_POST['text']) < 2) {
                        $error.= 'Текст должен содержать не менее 2 символов!<br/>';
                    }
                    elseif (mb_strlen($_POST['text']) > 2500) {
                        $error.= 'Текст должен содержать не более 2500 символов!<br/>';
                    }
                    if ($error) {
                        echo '<div class="menu">'.$error.'</div>';
                    } else {
                        $stmt = $connect->prepare("update `comments` set `text` = ? where `id` = ? limit 1");
                        if ($stmt->execute(array($_POST['text'], $_GET['edit']))) {
                            header('Location: /news/event/'.$id);
                        } else {
                            echo '<div class="menu">Произошла ошибка!</div>';
                        }
                    }
                }
                elseif (isset($_POST['no'])) {
                    header('Location: /news/event/'.$id);
                }
                echo '<div class="menu">
                <form action="" method="POST">
                Сообщение:<br/><textarea name="text" rows="5" cols="25">'.$row['text'].'</textarea><br/>
                <input type="submit" name="yes" value="Сохранить ('.intval($_GET['edit']).')"/>
                <input type="submit" name="no" value="Отмена"/>
                </form></div>';
            } else {
                header('Location: /news/event/'.$id);
            }
        }
        elseif (isset($_GET['cit'])) {
            $stmt_num->execute(array($_GET['cit'], $type, $id));
            if ($stmt_num->fetchColumn()) {
                $strow->execute(array($_GET['cit']));
                $row = $strow->fetch(PDO::FETCH_LAZY);
                if (isset($_POST['yes'])) {
                    $error = '';
                    if ($user['datereg'] > time() - 3600 * $sys['system']['fludtime'] && $adm_id == 0) {
                        $error.= 'Для возможности отправлять сообщения с момента регистрации должно пройти: '.restime(3600 * $sys['system']['fludtime']).'!<br/>';
                    }
                    elseif (isset($_SESSION['guest_add']) && $_SESSION['guest_add'] > time() - $sys['system']['antiflud']) {
                        $error.= 'Антифлуд! Лимит - '.quantDec($sys['system']['antiflud'], ['секунда', 'секунды', 'секунд']).'!<br/>';
                    }
                    elseif (empty($_POST['text'])) {
                        $error.= 'Введите сообщение!<br/>';
                    }
                    elseif (mb_strlen($_POST['text']) < 2) {
                        $error.= 'Текст должен содержать не менее 2 символов!<br/>';
                    }
                    elseif (mb_strlen($_POST['text']) > 2500) {
                        $error.= 'Текст должен содержать не более 2500 символов!<br/>';
                    }
                    if ($error) {
                        echo '<div class="menu">'.$error.'</div>';
                    } else {
                        if ($in_comment->execute(array(time(), $user['id'], $_POST['text'], $id, $type))) {
                            if ($n_row['uid'] != $user['id'])
                                notification('[b]'.$user['login'].'[/b] оставил комментарий к вашей новости [url='.ROOT.'/news/event/'.$id.']'.$n_row['name'].'[/url].', $n_row['uid']);
                            if ($row['uid'] != $user['id'] && $row['uid'] != $n_row['uid'])
                                notification('[b]'.$user['login'].'[/b] процитировал ваше сообщение в [url='.ROOT.'/news/event/'.$id.']Комментариях к новости[/url].', $row['uid']);
                            ratingUser($sys['rating']['chat'], $user['id']);
                            $_SESSION['guest_add'] = time();
                            header('Location: /news/event/'.$id);
                        } else {
                            echo '<div class="menu">Произошла ошибка!</div>';
                        }
                    }
                }
                elseif (isset($_POST['no'])) {
                    header('Location: /news/event/'.$id);
                }
                echo '<div class="menu">
                <form action="" method="POST">
                Сообщение:<br/><textarea name="text" rows="5" cols="25">[cit]'.str_replace(['[cit]', '[/cit]'], null, '[u]'.(user($row['uid']) ? (user($row['uid']) ? user($row['uid'])['login'] : 'DELETED') : 'DELETED').'[/u] ('.daytime($row['date']).')[br]'.$row['text']).'[/cit][br]</textarea><br/>
                <input type="submit" name="yes" value="Цитировать ('.intval($_GET['cit']).')"/>
                <input type="submit" name="no" value="Отмена"/>
                </form></div>';
            } else {
                header('Location: /news/event/'.$id);
            }
        } else {
            if (isset($_POST['refresh'])) {
                header('Location: /news/event/'.$id);
            }
            elseif (isset($_POST['addmess'])) {
                $error = '';
                if ($user['datereg'] > time() - 3600 * $sys['system']['fludtime'] && $adm_id == 0) {
                    $error.= 'Для возможности отправлять сообщения с момента регистрации должно пройти: '.restime(3600 * $sys['system']['fludtime']).'!<br/>';
                }
                elseif (isset($_SESSION['guest_add']) && $_SESSION['guest_add'] > time() - $sys['system']['antiflud']) {
                    $error.= 'Антифлуд! Лимит - '.quantDec($sys['system']['antiflud'], ['секунда', 'секунды', 'секунд']).'!<br/>';
                }
                elseif (empty($_POST['text'])) {
                    $error.= 'Введите сообщение!<br/>';
                }
                elseif (mb_strlen($_POST['text']) < 2) {
                    $error.= 'Текст должен содержать не менее 2 символов!<br/>';
                }
                elseif (mb_strlen($_POST['text']) > 2500) {
                    $error.= 'Текст должен содержать не более 2500 символов!<br/>';
                }
                if ($error) {
                    echo '<div class="menu">'.$error.'</div>';
                } else {
                    if ($in_comment->execute(array(time(), $user['id'], $_POST['text'], $id, $type))) {
                        if ($n_row['uid'] != $user['id'])
                            notification('[b]'.$user['login'].'[/b] оставил комментарий к вашей новости [url='.ROOT.'/news/event/'.$id.']'.$n_row['name'].'[/url].', $n_row['uid']);
                        if (isset($_GET['ans']) && $_GET['ans'] != $user['id'] && $_GET['ans'] != $n_row['uid'])
                            notification('[b]'.$user['login'].'[/b] ответил вам в [url='.ROOT.'/news/event/'.$id.']Комментариях к новости[/url].', $_GET['ans']);
                        ratingUser($sys['rating']['chat'], $user['id']);
                        $_SESSION['guest_add'] = time();
                        header('Location: /news/event/'.$id);
                    } else {
                        echo '<div class="menu">Ошибка при добавлении сообщения!</div>';
                    }
                }
            }
            echo '<form name="form" action="" method="POST">
            <div class="menu">
            Сообщение:<br/><textarea name="text" rows="5" cols="25">'.(isset($_GET['ans']) && user($_GET['ans']) && $_GET['ans'] != $user['login'] ? '[b]'.user($_GET['ans'])['login'].'[/b], ' : '').'</textarea><br/>
            <input type="submit" name="addmess" value="Написать"/>
            <input type="submit" name="refresh" value="Обновить">
            </form></div>';
        }
    }

    // модератору
    if ($adm_id == 1 || $adm_id == 2 || $adm_id == 3 || $adm_id == 5) {
        if (isset($_GET['del'])) {
            $stmt_num->execute(array($_GET['del'], $type, $id));
            if ($stmt_num->fetchColumn()) {
                if (isset($_POST['yes'])) {
                    $stmt = $connect->prepare("delete from `comments` where `id` = ?");
                    if ($stmt->execute(array($_GET['del']))) {
                        header('Location: /news/event/'.$id);
                    } else {
                        echo '<div class="menu">Произошла ошибка!</div>';
                    }
                }
                elseif (isset($_POST['no'])) {
                    header('Location: /news/event/'.$id);
                }
                echo '<div class="menu">
                <form action="" method="POST">
                <input type="submit" name="yes" value="Удалить ('.intval($_GET['del']).')"/>
                <input type="submit" name="no" value="Отмена"/>
                </form></div>';
            } else {
                header('Location: /news/event/'.$id);
            }
        }
        elseif (isset($_GET['clear'])) {
            if (isset($_POST['yes'])) {
                $clear = $connect->prepare("delete from `comments` where `did` = ? and `type` = ?");
                if ($clear->execute(array($id, $type))) {
                    header('Location: /news/event/'.$id);
                } else {
                    echo '<div class="menu">Произошла ошибка!</div>';
                }
            }
            elseif (isset($_POST['no'])) {
                header('Location: /news/event/'.$id);
            }
            echo '<div class="menu">
            <form action="" method="POST">
            <input type="submit" name="yes" value="Подтвердить очистку комментариев"/>
            <input type="submit" name="no" value="Отмена"/>
            </form></div>';
        } else {
            echo '<div class="forlink"><a href="?clear" class="links"><img src="/img/clear.png" alt="clear">Очистить комментарии</a></div>'; 
        }
    }

    if ($count_comm == 0) {
        echo '<div class="menu">Комментариев нет!</div>';
    } else {

        $page = new Pagination($count_comm, 10);

        $data = $connect->prepare("select * from `comments` where `did` = :did and `type` = :type order by `id` desc limit :start, 10");
        $data->bindValue(':did', $id, PDO::PARAM_INT);
        $data->bindValue(':type', $type, PDO::PARAM_INT);
        $data->bindValue(':start', $page->start, PDO::PARAM_INT);
        $data->execute();
        $sql = $data->fetchAll();

        foreach ($sql as $row) {
            echo '<div class="menu">'.profileLink($row['uid']).' ('.daytime($row['date']).')<span class="online">'.online($row['uid']).'</span>
            <div class="butt1">
            '.(isset($active) ? (user($row['uid']) && $row['uid'] != $user['id'] ? '<a href="?ans='.$row['uid'].'">Отв.</a>' : '').'<a href="?cit='.$row['id'].'">Цит.</a>'.($row['date'] > time() - 60 && $row['uid'] == $user['id'] ? '<a href="?edit='.$row['id'].'">Ред.</a>' : '') : '').
            (($adm_id == 1 || $adm_id == 2 || $adm_id == 3 || $adm_id == 5) ? '<a href="?del='.$row['id'].'">Уд.</a>' : '').'
            </div><hr/>'.nl2br(smiles(bb(bblinks($row['text'])))).'</div>';
        }

        $page->navigation();

    }

    echo '<div class="forlink"><a href="/news" class="links"><img src="/img/news.png" alt="">Новости сайта</a></div>';

} else {
    header('Location: /news');
}

require($_SERVER["DOCUMENT_ROOT"]."/inc/foot.php");
?>