<?php
$title = 'Добавить товар';
require_once($_SERVER["DOCUMENT_ROOT"]."/inc/head.php");
if (isset($active) && $sys['modules']['shop'] == 1) {

    echo '<div class="title">Добавить товар</div>';

    if ($count_shop_kat == 0) {
        echo '<div class="menu">Категорий нет!</div>';
    } else {
        if (isset($_POST['submit'])) {
            $error = '';
            if ((!$user['wmid'] || !$user['wmr']) && $sys['payment']['wmr'] && $sys['payment']['hash']) {
                $error.= 'У вас не подтверждены реквизиты!<br/>';
            } else {
                if (empty($_POST['name'])) {
                    $error.= 'Введите название товара!<br/>';
                }
                elseif (mb_strlen($_POST['name']) < 5 || mb_strlen($_POST['name']) > 250) {
                    $error.= 'Название должно содержать от 5 до 250 символов!<br/>';
                }
                if (empty($_POST['text'])) {
                    $error.= 'Введите описание товара!<br/>';
                }
                elseif (mb_strlen($_POST['text']) < 15 || mb_strlen($_POST['text']) > 15000) {
                    $error.= 'Описание должно содержать от 15 до 15000 символов!<br/>';
                }
                if (count(tagSearch($_POST['tags'])) > $sys['system']['stags']) {
                    $error.= 'Максимальное количество тегов - '.$sys['system']['stags'].'!<br/>';
                }
                if (empty($_POST['kat'])) {
                    $error.= 'Выберите категорию товара!<br/>';
                }
                if (empty($_POST['cena'])) {
                    $error.= 'Введите стоимость товара!<br/>';
                }
                elseif ($_POST['cena'] < $sys['system']['scena']) {
                    $error.= 'Минимальная стоимость товара - '.quantDec($sys['system']['scena'], ['рубль', 'рубля', 'рублей']).'!<br/>';
                }
                if ($_POST['uid'] != 0 && !user($_POST['uid'])) {
                    $error.= 'Пользователь с таким ID не найден в системе!<br/>';
                }
                elseif ($_POST['uid'] == $user['id']) {
                    $error.= 'Нельзя продавать самому себе!<br/>';
                }
                if (!file_exists($_FILES['filename']['tmp_name'])) {
                    $error.= 'Вы не выбрали файл!<br/>';
                }
                elseif (!in_array(get_extfile($_FILES['filename']['name']), ['zip', 'rar', '7z'])) {
                    $error.= 'Неверный тип файла: разрешено загружать только ZIP/RAR/7Z!<br/>';
                }
            }
            if ($error) {
                echo '<div class="menu">'.$error.'</div>';
            } else {

                $uid = intval($_POST['uid']);
                $col = $uid == 0 ? intval(abs($_POST['col'])) : 1;
                $cena = floatval($_POST['cena']);
                $limit = $col == 0 ? 0 : 1;
                $status = $adm_id == 1 ? 1 : 0; // Товары админа проходят без модерации

                $stmt = $connect->prepare("insert into `shop` set `time` = ?, `seller` = ?, `name` = ?, `text` = ?, `tags` = ?, `kat` = ?, `cena` = ?, `col` = ?, `limit` = ?, `uid` = ?, `status` = ?");

                if ($stmt->execute(array(time(), $user['id'], $_POST['name'], $_POST['text'], $_POST['tags'], $_POST['kat'], $cena, $col, $limit, $uid, $status))) {

                    $lid = $connect->LastInsertId();
                    $files = $lid."_".md5_file($_FILES['filename']['tmp_name'])."_".$_FILES['filename']['name'];
                    $full_path = $_SERVER["DOCUMENT_ROOT"]."/files/shop/".$files;

                    move_uploaded_file($_FILES['filename']['tmp_name'], $full_path);
                    chmod($full_path, 0444);

                    notification('В магазине опубликован [url='.ROOT.'/shop/product/'.$lid.']товар[/url] специально для Вас!', $uid);

                    header('Location: /shop/product/'.$lid);

                } else {
                    echo '<div class="menu">Произошла ошибка!</div>';
                }
            }
        }

        echo '<div class="menu">
        <form action="" method="POST" enctype="multipart/form-data">
        Название товара [5-250]:<br/><input type="text" name="name"><br/>
        Описание товара [15-15000]:<br/><textarea name="text" rows="3" cols="20"></textarea><br/>
        Теги (через запятую):<br/><input type="text" name="tags"><br/>
        Категория:<br/><select name="kat">';

        $sql = $connect->query("select * from `kat` where `type` = '1' order by `id` desc")->fetchAll();

        foreach ($sql as $kat_row) {

            echo '<option value="'.$kat_row['id'].'">'.$kat_row['name'].'</option>';

        }

        echo '</select><br/>
        Стоимость товара:<br/><input type="text" name="cena"><br/>
        Файл:<br/><input type="file" name="filename"><br/>
        Количество копий (0 - без ограничений):<br/><input type="text" name="col" value="0"><br/>
        ID покупателя (0 - доступен всем):<br/><input type="text" name="uid" value="0"><br/>
        <input type="submit" name="submit" value="Добавить товар">
        </form></div>';

    }

    echo '<div class="forlink"><a href="/shop/my" class="links"><img src="/img/myshop.png" alt="myshop">Мои товары</a></div>';

} else {
    header('Location: /');
}

require($_SERVER["DOCUMENT_ROOT"]."/inc/foot.php");
?>