<?php
$title = 'Просмотр товара';
require_once($_SERVER["DOCUMENT_ROOT"]."/inc/head.php");
if ($sys['modules']['shop'] == 1) {

    $strow = $connect->prepare("select * from `shop` where `id` = ?");
    $strow->execute(array($id));
    $row = $strow->fetch(PDO::FETCH_ASSOC);

    if ($row) {

        // prepared
        $del_screen = $connect->prepare("delete from `screen` where `id` = ?");
        $in_basket = $connect->prepare("insert into `basket` set `pid` = ?, `uid` = ?");
        $del_basket = $connect->prepare("delete from `basket` where `pid` = ? and `uid` = ?");
        $rating = $connect->prepare("select count(*) from `purchase` where `pid` = ? and `status` = ?");


        // продано копий
        $stmt_purch = $connect->prepare("select count(*) from `purchase` where `pid` = ?");
        $stmt_purch->execute(array($id));
        $purch = $stmt_purch->fetchColumn();
        // комментарии
        $stmt_comm->execute(array($id, 2));
        $count_comm = $stmt_comm->fetchColumn();
        // скрины
        $stmt_screen = $connect->prepare("select count(*) from `screen` where `did` = ? and `type` = '1'");
        $stmt_screen->execute(array($id));
        $count_screen = $stmt_screen->fetchColumn();
        // корзина
        $stmt_num_bk = $connect->prepare("select count(*) from `basket` where `pid` = ?");
        $stmt_num_bk->execute(array($id));
        $num_bk = $stmt_num_bk->fetchColumn();

        // категория
        $stmt_kat = $connect->prepare("select * from `kat` where `type` = '1' and `id` = ?");
        $stmt_kat->execute(array($row['kat']));
        $krow = $stmt_kat->fetch(PDO::FETCH_LAZY);

        // Файл
        $fileshop = fileshop($id);
        $type = $row['uid'] == 0 ? 'универсальный' : 'заказ для '.profileLink($row['uid']);
        $col = $row['limit'] == 0 ? 'не ограничено' : $row['col'];

        // Теги
        $tags = count(tagSearch($row['tags']));

        if (isset($active)) {

            /* Скидка */

            $stmt_dis = $connect->prepare("select * from `discounts` where `pid` = ? and `uid` = ?");
            $stmt_dis->execute(array($id, $user['id']));
            $discount = $stmt_dis->fetch(PDO::FETCH_LAZY);

            if ($discount) {
                if ($discount['sum'] < $row['cena'] && $row['uid'] == 0) {
                    $row['cena'] -= $discount['sum'];
                } else {
                    unset($discount);
                }
            }

            // наличие в покупках юзера
            $stmt_purchase = $connect->prepare("select count(*) from `purchase` where `pid` = ? and `uid` = ?");
            $stmt_purchase->execute(array($id, $user['id']));
            $user_purchase = $stmt_purchase->fetchColumn();
            // корзина
            $stmt_bk = $connect->prepare("select count(*) from `basket` where `pid` = ? and `uid` = ?");
            $stmt_bk->execute(array($id, $user['id']));
            $bk = $stmt_bk->fetchColumn();

            if (isset($_GET['ban']) && ($adm_id == 1 || $adm_id == 5 || $adm_id == 6)) {

                echo '<div class="title">Модерация товара</div>';

                if (isset($_POST['cancel'])) {
                    header('Location: /shop/product/'.$id);
                }
                elseif (isset($_POST['submit'])) {

                    $message = !empty($_POST['message']) ? '[br]Примечание: '.$_POST['message'] : '';
                    $stmt = $connect->prepare("update `shop` set `time` = ?, `status` = ? where `id` = ?");

                    if ($stmt->execute(array(time(), $_POST['status'], $id))) {

                        if ($row['seller'] != $user['id'])
                            notification('Ваш товар [url='.ROOT.'/shop/product/'.$row['id'].']'.$row['name'].'[/url] '.($status == 1 ? 'одобрен' : 'не одобрен').' для участия в продажах.'.$message, $row['seller']);

                        header('Location: /shop/product/'.$id);

                    } else {
                        echo '<div class="menu">Произошла ошибка!</div>';
                    }
                }

                echo '<div class="menu">
                <form action="" method="POST">
                Выберите действие:<br/>
                <select name="status">
                <option value="1">Разместить в магазине</option>
                <option value="0">Не размещать в магазине</option>
                </select><br/>
                Примечание:<br/><textarea name="message"></textarea><br/>
                <input type="submit" name="submit" value="Продолжить">
                <input type="submit" name="cancel" value="Отмена">
                </form></div>';

            }

            if ($adm_id == 1 || $row['seller'] == $user['id']) {

                if (isset($_GET['del'])) {

                    echo '<div class="title">Удаление товара</div>';

                    // платежи
                    $stmt_p = $connect->prepare("select count(*) from `purchase` where `status` != '1' and `pid` = ?");
                    $stmt_p->execute(array($id));

                    if (!$stmt_p->fetchColumn()) {
                        if (isset($_POST['cancel'])) {
                            header('Location: /shop/product/'.$id);
                        }
                        elseif (isset($_POST['del'])) {

                            $del_shop = $connect->prepare("delete from `shop` where `id` = ?");
                            $del_basket = $connect->prepare("delete from `basket` where `pid` = ?");
                            $del_dis = $connect->prepare("delete from `discounts` where `pid` = ?");
                            $del_screen = $connect->prepare("delete from `screen` where `did` = ? and `type` = '1'");
                            $del_comm = $connect->prepare("delete from `comments` where `did` = ? and `type` = '2'");

                            if ($del_shop->execute(array($id)) &&
                                $del_basket->execute(array($id)) &&
                                $del_dis->execute(array($id)) &&
                                $del_comm->execute(array($id))) {

                                /* Чистим мусор */

                                $data = $connect->prepare("select * from `screen` where `did` = :did  and `type` = '1' order by `id` desc");
                                $data->bindValue(':did', $id, PDO::PARAM_INT);
                                $data->execute();
                                $sql = $data->fetchAll();

                                foreach ($sql as $scrow) {

                                    $filescreen = $_SERVER["DOCUMENT_ROOT"].'/files/'.$scrow['file'];

                                    if (is_file($filescreen))
                                        unlink($filescreen);

                                }

                                $del_screen->execute(array($id));

                                if (!$purch && $fileshop)
                                    unlink($fileshop);

                                header('Location: /shop');

                            } else {
                                echo '<div class="menu">Произошла ошибка!</div>';
                            }
                        }

                        echo '<div class="menu">
                        <form action="" method="POST">
                        <input type="submit" name="del" value="Подтвердить удаление">
                        <input type="submit" name="cancel" value="Отмена">
                        </form></div>';

                    } else {
                        header('Location: /shop/product/'.$id);
                    }
                }
                elseif (isset($_GET['edit'])) {

                    echo '<div class="title">Редактирование товара</div>';

                    if (isset($_POST['cancel'])) {
                        header('Location: /shop/product/'.$id);
                    }
                    elseif (isset($_POST['edit'])) {

                        $error = '';

                        if (empty($_POST['name'])) {
                            $error.= 'Введите название товара!<br/>';
                        }
                        elseif (mb_strlen($_POST['name']) < 5 || mb_strlen($_POST['name']) > 250) {
                            $error.= 'Название должно содержать от 5 до 250 символов!<br/>';
                        }
                        if (empty($_POST['text'])) {
                            $error.= 'Введите описание товара!<br/>';
                        }
                        elseif (mb_strlen($_POST['text']) < 15 || mb_strlen($_POST['text']) > 15000) {
                            $error.= 'Описание должно содержать от 15 до 15000 символов!<br/>';
                        }
                        if (count(tagSearch($_POST['tags'])) > $sys['system']['stags']) {
                            $error.= 'Максимальное количество тегов - '.$sys['system']['stags'].'!<br/>';
                        }
                        if (empty($_POST['kat'])) {
                            $error.= 'Выберите категорию товара!<br/>';
                        }
                        if (empty($_POST['cena'])) {
                            $error.= 'Введите стоимость товара!<br/>';
                        }
                        elseif ($_POST['cena'] < $sys['system']['scena']) {
                            $error.= 'Минимальная стоимость товара - '.quantDec($sys['system']['scena'], ['рубль', 'рубля', 'рублей']).'!<br/>';
                        }
                        if ($_POST['uid'] != 0 && !user($_POST['uid'])) {
                            $error.= 'Пользователь с таким ID не найден в системе!<br/>';
                        }
                        elseif ($_POST['uid'] == $user['id']) {
                            $error.= 'Нельзя продавать самому себе!<br/>';
                        }
                        if ($error) {
                            echo '<div class="menu">'.$error.'</div>';
                        } else {

                            $uid = intval($_POST['uid']);
                            $col = $uid == 0 ? intval(abs($_POST['col'])) : 1;
                            $cena = floatval($_POST['cena']);
                            $limit = $col == 0 ? 0 : 1;

                            $stmt = $connect->prepare("update `shop` set `name` = ?, `text` = ?, `tags` = ?, `kat` = ?, `cena` = ?, `col` = ?, `limit` = ?, `uid` = ? where `id` = ?");

                            if ($stmt->execute(array($_POST['name'], $_POST['text'], $_POST['tags'], $_POST['kat'], $cena, $col, $limit, $uid, $id))) {

                                notification('В магазине опубликован [url='.ROOT.'/shop/product/'.$id.']товар[/url] специально для Вас!', $uid);

                                header('Location: /shop/product/'.$id);

                            } else {
                                echo '<div class="menu">Произошла ошибка!</div>';
                            }
                        }
                    }

                    echo '<div class="menu">
                    <form action="" method="POST">
                    Название товара [5-250]:<br/><input type="text" name="name" value="'.$row['name'].'"><br/>
                    Описание товара [15-15000]:<br/><textarea name="text" rows="3" cols="20">'.$row['text'].'</textarea><br/>
                    Теги (через запятую):<br/><input type="text" name="tags" value="'.$row['tags'].'"><br/>
                    Категория:<br/><select name="kat">';

                    $sql = $connect->query("select * from `kat` where `type` = '1' order by `id` desc")->fetchAll();

                    foreach ($sql as $kat_row) {

                        echo '<option ' . ($row['kat'] == $kat_row['id'] ? 'selected' : '') . ' value="'.$kat_row['id'].'">'.$kat_row['name'].'</option>';

                    }

                    echo '</select><br/> 
                    Стоимость товара:<br/><input type="text" name="cena" value="'.$row['cena'].'"><br/>
                    Количество копий (0 - без ограничений):<br/><input type="text" name="col" value="'.$row['col'].'"><br/>
                    ID покупателя (0 - доступен всем):<br/><input type="text" name="uid" value="'.$row['uid'].'"><br/>
                    <input type="submit" name="edit" value="Сохранить">
                    <input type="submit" name="cancel" value="Отмена">
                    </form></div>';

                }

            }

            if ($row['seller'] == $user['id']) {

                if (isset($_GET['screen'])) {

                    echo '<div class="title">Загрузка скриншотов</div>';

                    if (isset($_POST['cancel'])) {
                        header('Location: /shop/product/'.$id);
                    }
                    elseif (isset($_POST['upload_screen'])) {

                        $error = '';

                        $reFiles = reArrayFiles($_FILES['filename']);

                        if (isset($_SESSION['scr_time']) && $_SESSION['scr_time'] > time() - 30) {
                            $error.= 'Нельзя загружать файлы чаще, чем раз в 30 секунд!<br/>';
                        }
                        elseif (count($reFiles) > 10) {
                            $error.= 'Нельзя загружать более 10 файлов одновременно!<br/>';
                        } else {
                            foreach ($reFiles as $file) {
                                if (file_exists($file['tmp_name'])) {
                                    $file_find = 1; // файлы есть
                                    if (!in_array(get_extfile($file['name']), ['jpg', 'png']) || !exif_imagetype($file['tmp_name'])) {
                                        $error.= $file['name'] . ': неверный тип файла!<br/>';
                                    }
                                    if ($file['size'] > 1024 * 1024) {
                                        $error.= $file['name'] . ': максимальный размер файла - 1 Mb!<br/>';
                                    }
                                }
                            }
                            if (!isset($file_find)) {
                                $error.= 'Выберите хотя бы один файл!<br/>';
                            }
                        }
                        if ($error) {
                            echo '<div class="menu">'.$error.'</div>';
                        } else {

                            $new_screen = $connect->prepare("insert into `screen` set `file` = ?, `did` = ?, `type` = '1'");
                            $path = $_SERVER["DOCUMENT_ROOT"]."/files/";

                            foreach ($reFiles as $file) {
                                if (file_exists($file['tmp_name'])) {
                                    // Записываем в бд
                                    $files = $id."_".$user['id']."_".random_int(11111, 99999)."_".$file['name'];
                                    $new_screen->execute(array($files, $id));
                                    // Заливаем
                                    $full_path = $path . $files;
                                    move_uploaded_file($file['tmp_name'], $full_path);
                                }
                            }

                            $_SESSION['scr_time'] = time();

                            header('Location: /shop/product/'.$id);

                        }

                    }

                    echo '<div class="menu">
                    <form action="" method="POST" enctype="multipart/form-data">
                    <input type="file" name="filename[]" id="file"><br/>
                    <input type="file" name="filename[]" id="file"><br/>
                    <input type="file" name="filename[]" id="file"><br/>
                    <input type="file" name="filename[]" id="file"><br/>
                    <input type="file" name="filename[]" id="file"><br/>
                    <div class="butt1" id="pre"><a href="javascript:AddFile()">Добавить еще</a></div><br/>
                    <input type="submit" name="upload_screen" value="Загрузить">
                    <input type="submit" name="cancel" value="Отмена">
                    </form></div>';

                }
                elseif (isset($_GET['upd'])) {

                    echo '<div class="title">Замена архива</div>';

                    if (isset($_POST['cancel'])) {
                        header('Location: /shop/product/'.$id);
                    }
                    elseif (isset($_POST['uploadnew'])) {

                        $error = '';

                        if (!file_exists($_FILES['filename']['tmp_name'])) {
                            $error.= 'Вы не выбрали файл!<br/>';
                        }
                        elseif (!in_array(get_extfile($_FILES['filename']['name']), ['zip', 'rar', '7z'])) {
                            $error.= 'Неверный тип файла: разрешено загружать только ZIP/RAR/7Z!<br/>';
                        }
                        if ($error) {
                            echo '<div class="menu">'.$error.'</div>';
                        } else {

                            $update = $connect->prepare("update `shop` set `upd` = ? where `id` = ?");

                            if ($update->execute(array(time(), $id))) {

                                if ($fileshop)
                                    unlink($fileshop);
 
                                $files = $id."_".md5_file($_FILES['filename']['tmp_name'])."_".$_FILES['filename']['name'];
                                $full_path = $_SERVER["DOCUMENT_ROOT"]."/files/shop/".$files;

                                move_uploaded_file($_FILES['filename']['tmp_name'], $full_path);
                                chmod($full_path, 0444);

                                header('Location: /shop/product/'.$id);

                            } else {
                                echo '<div class="menu">Произошла ошибка!</div>';
                            }

                        }

                    }

                    echo '<div class="menu">
                    <form action="" method="POST" enctype="multipart/form-data">
                    Файл:<br/><input type="file" name="filename"><br/>
                    <input type="submit" name="uploadnew" value="Заменить">
                    <input type="submit" name="cancel" value="Отмена">
                    </form></div>';

                }

            }

        }

        echo '<div class="title">Просмотр товара: '.$row['name'].'</div>';

        if (isset($active)) {

            if (isset($_GET['bk']) && $row['seller'] != $user['id'] && !$user_purchase) {

                if (isset($_POST['cancel'])) {
                    header('Location: /shop/product/'.$id);
                }
                elseif (isset($_POST['yes'])) {

                    if (!$bk) {

                        notification('[b]'.$user['login'].'[/b] добавил ваш товар [url='.ROOT.'/shop/product/'.$id.']'.$row['name'].'[/url] в корзину.', $row['seller']);

                        $in_basket->execute(array($id, $user['id']));

                    } else {

                        $del_basket->execute(array($id, $user['id']));

                    }

                    header('Location: /shop/product/'.$id);

                }

                echo '<div class="menu">
                <form action="" method="POST">
                <input type="submit" name="yes" value="'.(!$bk ? 'Добавить в корзину' : 'Удалить из корзины').'">
                <input type="submit" name="cancel" value="Отмена">
                </form></div>';

            }
            elseif (isset($_GET['dsc']) && $row['seller'] == $user['id']) {

                $stmt_num = $connect->prepare("select count(*) from `screen` where `id` = ? and `did` = ? and `type` = '1'");
                $stmt_num->execute(array($_GET['dsc'], $id));

                if (!$stmt_num->fetchColumn()) {
                    header('Location: /shop/product/'.$id);
                } else {

                    $stmt_scrow = $connect->prepare("select * from `screen` where `id` = ?");
                    $stmt_scrow->execute(array($_GET['dsc']));
                    $scrow = $stmt_scrow->fetch(PDO::FETCH_LAZY);

                    if (isset($_POST['cancel'])) {
                        header('Location: /shop/product/'.$id);
                    }
                    elseif (isset($_POST['yes'])) {

                        if ($del_screen->execute(array($_GET['dsc']))) {

                            $screen_path = $_SERVER["DOCUMENT_ROOT"]."/files/".$scrow['file'];

                            if (is_file($screen_path))
                                unlink($screen_path);

                            header('Location: /shop/product/'.$id);

                        } else {
                            echo '<div class="menu">Произошла ошибка!</div>';
                        }

                    }

                    echo '<div class="menu">
                    <form action="" method="POST">
                    <input type="submit" name="yes" value="Удалить скриншот ('.intval($_GET['dsc']).')">
                    <input type="submit" name="cancel" value="Отмена">
                    </form></div>';

                }

            }

        }

        if ($count_screen > 0) {

            $page = new Pagination($count_screen, 1);

            $data = $connect->prepare("select * from `screen` where `did` = :did  and `type` = '1' order by `id` limit :start, 1");
            $data->bindValue(':did', $id, PDO::PARAM_INT);
            $data->bindValue(':start', $page->start, PDO::PARAM_INT); 
            $data->execute();
            $sql = $data->fetchAll();

            foreach ($sql as $scrow) {

                $screen = '/files/'.$scrow['file'];

                echo '<div class="menu">
                <img src="/preview/160x0/'.base64_encode($screen).'" alt="preview" class="img-thumbnail" data-toggle="modal" data-target="#screen">
                '.(isset($active) && $row['seller'] == $user['id'] ? '<div class="butt1"><a href="?dsc='.$scrow['id'].'">Удалить скриншот</a></div>' : '').'
                </div>
                <div id="screen" class="modal fade" tabindex="-1">
                  <div class="modal-dialog">
                    <img src="'.$screen.'" alt="screen" class="img-thumbnail" data-dismiss="modal">
                  </div>
                </div>';

            }

            $page->navigation();

        }

        echo '<div class="menu">'.nl2br(smiles(bb(bbyoutube(bblinks($row['text']))))).'</div>
        <div class="menu">
        Продавец: '.profileLink($row['seller']).'<br/>
        Количество копий: '.$col.'<br/>
        Продано копий: '.$purch.'<br/>
        Добавили в корзину: '.$num_bk.' чел.<br/>
        Тип: '.$type.'<br/>
        Размер файла: '.get_filesize($fileshop).'<br/>
        Дата добавления: '.daytime($row['time']).'<br/>
        '.($row['upd'] ? 'Последнее обновление: '.daytime($row['upd']).'<br/>' : '').'
        Стоимость: '.(isset($discount['sum']) ? '<font color="#d8544f"><del>'.($row['cena'] + $discount['sum']).'</del></font> ' : '').
        quantDec($row['cena'], ['рубль', 'рубля', 'рублей']).
        ($row['tags'] && $tags > 0 ? '<div class="dash">Теги: '.taglink($row['tags'], '/shop/search?search=').'</div>' : '').'
        <div class="butt2">
        <a href="/shop/seller/'.$row['seller'].'">Все товары автора</a><br/>
        <a href="/shop/comments/'.$id.'">Комментарии ('.$count_comm.')</a>
        '.(isset($active) ? ($row['seller'] == $user['id'] ? '
        <a href="?screen">Загрузить скриншоты</a><br/>
        <a href="/shop/download/'.$id.'">Скачать</a>
        <a href="?upd">Замена архива</a><br/>
        '.($row['uid'] == 0 ? '<a href="/shop/discounts/'.$id.'">Скидки на товар</a>' : '') :
        (!$user_purchase ? '<a href="?bk">'.(!$bk ? 'В корзину' : 'Удалить из корзины').'</a>' : '')).
        (($adm_id == 1 || $row['seller'] == $user['id']) ? '<a href="/shop/pays/'.$id.'">Покупатели ('.$purch.')</a><br/>
        <a href="?del">Удалить</a>
        <a href="?edit">Редактировать</a>' : '').
        (($adm_id == 1 || $adm_id == 5 || $adm_id == 6) ? '<a href="?ban">Модерация</a>' : '') : '').'
        </div></div>';

        if (isset($active)) {

            if ($row['seller'] != $user['id'] && $row['status'] == 1) {

                if ($user_purchase) {

                    echo '<div class="forlink"><a href="/shop/download/'.$id.'" class="links"><img src="/img/download.png" alt="download">Скачать</a></div>';

                } elseif ($row['limit'] == 1 && $row['col'] <= 0) {

                    echo '<div class="menu"><div class="information">Все копии распроданы!</div></div>';

                } elseif ($row['uid'] != 0 && $row['uid'] != $user['id']) {

                    echo '<div class="menu"><div class="information">Этот товар не для вас!</div></div>';

                } elseif ((!$user['wmid'] || !$user['wmr']) && $sys['payment']['wmr'] && $sys['payment']['hash']) {

                    echo '<div class="menu"><div class="danger">Подтвердите реквизиты, чтобы была возможность купить товар!</div></div>';

                } elseif ($user['money'] < $row['cena']) {

                    echo '<div class="menu"><div class="information">Недостаточно средств для покупки!</div></div>';

                } elseif (isset($_GET['buy'])) {

                    if (isset($_POST['cancel'])) {

                        header('Location: /shop/product/'.$id);

                    }
                    elseif (isset($_POST['yes'])) {

                        // покупка
                        $buy = $connect->prepare("insert into `purchase` set `time` = ?, `pid` = ?, `name` = ?, `uid` = ?, `seller` = ?, `sum` = ?");
                        $stmt = $connect->prepare("update `shop` set `col` = `col` - '1' where `id` = ?");
                        $del_discount = $connect->prepare("delete from `discounts` where `id` = ?");

                        if (pay(-$row['cena'], $user['id']) && $buy->execute(array(time(), $id, $row['name'], $user['id'], $row['seller'], $row['cena']))) {

                            notification('[b]'.$user['login'].'[/b] купил ваш товар [url='.ROOT.'/shop/product/'.$id.']'.$row['name'].'[/url]', $row['seller']);

                            ratingUser($sys['rating']['buy'], $user['id']);

                            if ($row['limit'] == 1)
                                $stmt->execute(array($id));

                            if ($bk)
                                $del_basket->execute(array($id, $user['id']));

                            if (isset($discount['id']))
                                $del_discount->execute(array($discount['id']));

                            header('Location: /shop/purchase');

                        } else {

                            echo '<div class="menu">Произошла ошибка!</div>';

                        }

                    } else {

                        echo '<div class="menu">
                        <form action="" method="POST">
                        Скидка: '.(isset($discount['sum']) ? '<font color="#4cae4c">'.quantDec($discount['sum'], ['рубль', 'рубля', 'рублей']).'</font>' : '<font color="#d8544f">Нет</font>').'<hr/>
                        <input type="submit" name="yes" value="Подтвердить покупку">
                        <input type="submit" name="cancel" value="Отмена">
                        </form></div>';

                    }

                } else {

                    echo '<div class="forlink"><a href="?buy" class="links"><img src="/img/money.png" alt="buy">Купить</a></div>';

                }

            }

        } else {

            echo '<div class="menu"><div class="information">Авторизуйтесь, чтобы была возможность купить товар.</div></div>';

        }

        if ($krow)
            echo '<div class="forlink"><a href="/shop/category/'.$krow['id'].'" class="links"><img src="/img/folder.png" alt="folder">'.$krow['name'].'</a></div>';

        echo '<div class="forlink"><a href="/shop" class="links"><img src="/img/shop.png" alt="">Магазин скриптов</a></div>';

    } else {
        header('Location: /');
    }
} else {
    header('Location: /');
}

require($_SERVER["DOCUMENT_ROOT"]."/inc/foot.php");
?>