<?php
$title = 'Мои покупки';
require_once($_SERVER["DOCUMENT_ROOT"]."/inc/head.php");
if (isset($active) && $sys['modules']['shop'] == 1) {

    echo '<div class="title">Мои покупки</div>';

    $stmt_num = $connect->prepare("select count(*) from `purchase` where `status` != '1' and `uid` = ? and `id` = ?");
    $strow = $connect->prepare("select * from `purchase` where `id` = ?");

    if (isset($_GET['review'])) {
        $stmt_num->execute(array($user['id'], $_GET['review']));
        if ($stmt_num->fetchColumn()) {
            $strow->execute(array($_GET['review']));
            $row = $strow->fetch(PDO::FETCH_LAZY);
            if (isset($_POST['yes'])) {
                $error = '';
                if (empty($_POST['status'])) {
                    $error.= 'Укажите тип отзыва!<br/>';
                }
                if (mb_strlen($_POST['review']) > 2500) {
                    $error.= 'Отзыв должен содержать не более 2500 символов!<br/>';
                }
                if ($error) {
                    echo '<div class="menu">'.$error.'</div>';
                } else {

                    $stmt = $connect->prepare("update `purchase` set `status` = ?, `review` = ? where `uid` = ? and `id` = ?");

                    if ($stmt->execute(array($_POST['status'], $_POST['review'], $user['id'], $_GET['review']))) {

                        /* Обработка платежа */

                        if ($_POST['status'] == 1) {

                            // Рейтинг
                            ratingUser($sys['rating']['shop'], $row['seller']);

                            // Выплата
                            $money = $connect->prepare("update `users` set `money` = `money` + ? where `id` = ?");
                            $money->execute(array($row['sum'], $row['seller']));

                        }

                        notification('[b]'.$user['login'].'[/b] оставил к вашему товару [url='.ROOT.'/shop/product/'.$row['pid'].']'.$row['name'].'[/url] '.($_POST['status'] == 1 ? '[color=green]положительный[/color]' : '[color=red]отрицательный[/color]').' [url='.ROOT.'/shop/pays/'.$row['pid'].']отзыв[/url].', $row['seller']);

                        header('Location: /shop/purchase');

                    } else {
                        echo '<div class="menu">Произошла ошибка!</div>';
                    }
                }
            }
            elseif (isset($_POST['no'])) {
                header('Location: /shop/purchase');
            }
            echo '<div class="menu">
            <form action="" method="POST">
            Отзыв:<br/>
            <textarea name="review"></textarea><br/>
            <select name="status">
            <option value="1">Положительный</option>
            <option value="2">Отрицательный</option>
            </select><br/>
            <input type="submit" name="yes" value="Отправить">
            <input type="submit" name="no" value="Отмена">
            </form></div>';
        } else {
            header('Location: /shop/purchase');
        }
    }

    if ($user_purch == 0) {
        echo '<div class="menu">Покупок нет.</div>';
    } else {

        echo '<div class="menu">
        Покупок за все время: '.$user_purch.'<br/>
        На сумму: '.quantDec($sum_user_purch, ['рубль', 'рубля', 'рублей']).'
        </div>';

        $page = new Pagination($user_purch, 10);

        $data = $connect->prepare("select * from `purchase` where `uid` = :uid order by `id` desc limit :start, 10");
        $data->bindValue(':uid', $user['id'], PDO::PARAM_INT);
        $data->bindValue(':start', $page->start, PDO::PARAM_INT);
        $data->execute();
        $sql = $data->fetchAll();

        foreach ($sql as $row) {

            $fileshop = fileshop($row['pid']);

            echo '<div class="menu">
            <div class="forlink-bordered"><a href="/shop/product/'.$row['pid'].'" class="links"><img src="/img/product.png" alt="product">'.$row['name'].'</a></div>
            Размер файла: '.get_filesize($fileshop).'<br/>
            Дата покупки: '.daytime($row['time']).'
            <div class="butt2">
            <a href="/shop/download/'.$row['pid'].'">Загрузить</a>
            '.($row['status'] != 1 ? '<a href="?review='.$row['id'].'">Отзыв</a>' : '').'
            </div></div>';

        }

        $page->navigation();

    }

    echo '<div class="forlink"><a href="/shop" class="links"><img src="/img/shop.png" alt="">Магазин скриптов</a></div>';

} else {
    header('Location: /');
}

require($_SERVER["DOCUMENT_ROOT"]."/inc/foot.php");
?>