<?php
$title = 'Профиль';
require_once($_SERVER["DOCUMENT_ROOT"]."/inc/head.php");

$row = user($id);

if ($row) {

    $auth = authlog($id);

    echo '<div class="title">Профиль<span class="count">'.iconUser($id) . gradientUser($row['login']).'</span></div>';

    // prepared
    $del_black = $connect->prepare("delete from `blacklist` where `uid` = ? and `black` = ?");
    $in_black = $connect->prepare("insert into `blacklist` set `uid` = ?, `black` = ?");
    $in_friend = $connect->prepare("insert into `friend` set `from` = ?, `to` = ?");
    $del_contact = $connect->prepare("delete from `contacts` where `from` = :from and `to` = :to or `from` = :to and `to` = :from");
    $del_mail = $connect->prepare("delete from `mail` where `from` = :user and `to` = :who or `from` = :who and `to` = :user");
    $review = $connect->prepare("select count(*) from `respect` where `to` = ? and `review` = ?");

    // Плюсы
    $review->execute(array($id, 1));
    $plus = $review->fetchColumn();
    // Минусы
    $review->execute(array($id, 0));
    $minus = $review->fetchColumn();
    // Репутация
    $respect = $plus - $minus;

    // Рефералы
    $stmt_ref->execute(array($id));
    $ref = $stmt_ref->fetchColumn();
    // Выплачено юзеру
    $stmt_user_payment->execute(array($id));
    $u_payment = $stmt_user_payment->fetchColumn() ?? 0;

    // Друзья
    $stmt_friends->bindValue(':user', $id, PDO::PARAM_INT);
    $stmt_friends->execute();
    $count_fr = $stmt_friends->fetchColumn();

    // Иконка пользователя
    $icon = getUserIcon($id);

    // День рождения
    $birth = DateTime::createFromFormat('Y-m-d', $row['birth']);

    // Happy Birthsday!
    if ($birth && date('d.m') == $birth->format('d.m'))
        echo '<div class="menu"><img src="/img/cake.png" alt="cake">Сегодня у '.($row['pol'] == 1 ? 'него' : 'неё').' День рождения!</div>';

    if (!online($id) && $auth)
        echo '<div class="menu">Последний визит: '.daytime($auth['lasttime']).deviceIcon($auth['ua']).'</div>';

    if (isset($active)) {
        if (isset($_GET['black']) && $id != $user['id']) {
            if (isset($_POST['cancel'])) {
                header('Location: /user/'.$id); 
            }
            elseif (isset($_POST['yes'])) {

                if (in_blacklist($user['id'], $id)) {

                    if ($del_black->execute(array($user['id'], $id))) {

                        header('Location: /user/'.$id);

                    } else {
                        echo '<div class="menu">Произошла ошибка!</div>';
                    }

                } else {

                    if ($in_black->execute(array($user['id'], $id)) &&
                        $del_contact->execute(array(':from' => $user['id'], ':to' => $id)) &&
                        $del_mail->execute(array(':user' => $user['id'], ':who' => $id))) {

                        header('Location: /user/'.$id);

                    } else {
                        echo '<div class="menu">Произошла ошибка!</div>';
                    }

                }
            }

            echo '<div class="menu">
            <form action="" method="POST">
            <input type="submit" name="yes" value="'.(in_blacklist($user['id'], $id) ? 'Удалить из ЧС' : 'Добавить в ЧС').'">
            <input type="submit" name="cancel" value="Отмена">
            </form></div>';

        }
        elseif (isset($_GET['respect']) && $id != $user['id'] && !in_blacklist($id, $user['id'])) {
            $stmt_count = $connect->prepare("select count(*) from `respect` where `from` = ? and `to` = ?");
            $stmt_count->execute(array($user['id'], $id));
            if (!$stmt_count->fetchColumn()) {
                // Отзыв
                $status = $_GET['respect'] == 1 ? 1 : 0;
                if (isset($_POST['cancel'])) {
                    header('Location: /user/'.$id);
                }
                elseif (isset($_POST['review'])) {
                    $message = !empty($_POST['message']) ? '[br]Примечание: '.$_POST['message'] : '';
                    $stmt = $connect->prepare("insert into `respect` set `review` = ?, `from` = ?, `to` = ?");
                    $stmt->execute(array($status, $user['id'], $id));
                    notification('[b]'.$user['login'].'[/b] '.($status == 1 ? '[color=green]повысил[/color]' : '[color=red]понизил[/color]').' вашу репутацию.'.$message, $id);
                    header('Location: /user/'.$id);
                }
                echo '<div class="menu">
                <form action="" method="POST">
                '.($status == 1 ? 'Повышение репутации' : 'Понижение репутации').'<hr/>
                Примечание:<br/><textarea name="message"></textarea><br/>
                <input type="submit" name="review" value="Продолжить">
                <input type="submit" name="cancel" value="Отмена">
                </form></div>';
            } else {
                header('Location: /user/'.$id);
            }
        }
    }

    echo '<div class="menu">
    '.($row['ban'] > time() ? '<div class="danger">Этот пользователь заблокирован!</div>' : '').'
    <span class="online">'.online($id).'</span>';

    $avatar = getUserAvatar($id);

    if ($avatar) {

        echo '<img src="/preview/'.$sys['system']['wava'].'/'.base64_encode('/files/avatar/'.basename($avatar)).'" alt="preview" class="img-rounded" data-toggle="modal" data-target="#avatar">
        <div id="avatar" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
            <img src="/files/avatar/'.basename($avatar).'" alt="avatar" class="img-thumbnail" data-dismiss="modal">
          </div>
        </div>';

    } else {

        echo '<img src="/files/avatar/no_avatar.png" alt="no_avatar">';

    }

    echo ($row['status'] ? '<div class="status_a"></div><div class="status">'.nl2br(smiles(bb($row['status']))).'</div>' : '').'</div>
    '.($row['admin'] != 0 && isset($levels[$row['admin']]) ? '<div class="menu"><div class="looks">'.($row['adm_pos'] ? $row['adm_pos'] : $levels[$row['admin']]).'</div></div>' : '');

    if (isset($active) && $id != $user['id'] && !in_blacklist($user['id'], $id) && !in_blacklist($id, $user['id'])) {

        /* Добавление/удаление из друзей */

        $strow_fr = $connect->prepare("select * from `friend` where `from` = :from and `to` = :to or `from` = :to and `to` = :from");
        $strow_fr->bindValue(':from', $id, PDO::PARAM_INT);
        $strow_fr->bindValue(':to', $user['id'], PDO::PARAM_INT);
        $strow_fr->execute();
        $friend = $strow_fr->fetch(PDO::FETCH_ASSOC);

        if (isset($_GET['friend']) && (($friend && ($friend['status'] == 1 || $friend['status'] == 0 && $friend['from'] == $user['id'])) || !$friend)) {

            if (isset($_POST['ok'])) {

                if (!$friend) {

                    $in_friend->execute(array($user['id'], $id));

                } elseif ($friend['status'] == 1 || $friend['status'] == 0 && $friend['from'] == $user['id']) {

                    if ($friend['status'] == 1)
                        notification('[b]'.$user['login'].'[/b] удалил вас из друзей.', $id);

                    $del_friend->execute(array(':from' => $id, ':to' => $user['id']));

                }

                header('Location: /user/'.$id);

            }
            elseif (isset($_POST['cancel'])) {

                header('Location: /user/'.$id);

            }

            echo '<div class="menu">
            <form action="" method="POST">
            <input type="submit" name="ok" value="Подтвердить"/> 
            <input type="submit" name="cancel" value="Отмена"/>
            </form></div>';

        }

        echo '<div class="menu">
        <table class="row_table">
        <tr>';

        if (privateMail($id, $user['id']))
            echo '<td class="row_table_column" width="50%"><a href="/mail/read/'.$id.'" class="butt9">Написать сообщение</a></td>';

        if (($friend && ($friend['status'] == 1 || $friend['status'] == 0 && $friend['from'] == $user['id'])) || !$friend)
            echo '<td class="row_table_column" width="50%"><a href="?friend" class="butt9">'.($friend && $friend['status'] == 0 && $friend['from'] == $user['id'] ? 'Отменить заявку' : ($friend && $friend['status'] == 1 ? 'Удалить из друзей' : 'Добавить в друзья')).'</a></td>';

        echo '</tr></table></div>';

    }

    echo '<div class="menu">
    '.($row['name'] ? 'Имя: '.$row['name'].'<br/>' : '').
    ($row['info'] ? 'О себе: '.$row['info'].'<br/>' : '').'
    Пол: '.($row['pol'] == 1 ? 'Мужской' : 'Женский').'<br/>
    '.($birth ? ($row['hd'] == 1 ? 'День рождения: '.$birth->format('d.m') : 'Дата рождения: '.$birth->format('d.m.Y')) : '').'
    </div>
    <div class="menu">
    Друзей: '.$count_fr.'<br/>
    Рефералов: '.$ref.'<br/>
    '.(user($row['ref']) ? 'Пригласил: '.profileLink($row['ref']).'<br/>' : '').'
    Выплачено: '.quantDec($u_payment, ['рубль', 'рубля', 'рублей']).'<br/>
    Рейтинг: '.rankUser($row['rating']).'<br/>
    Репутация: '.$respect.' [<a href="?respect=1"><font color="#4cae4c">+'.$plus.'</font></a>|<a href="?respect=0"><font color="#d8544f">-'.$minus.'</font></a>]
    </div>
    <div class="menu">
    Дата регистрации: '.daytime($row['datereg']).'<br/>
    ID: '.$row['id'].'
    </div>';

    if (isset($active)) {

        if ($id != $user['id'])
            echo '<div class="forlink"><a href="?black" class="links"><img src="/img/nonotif.png" alt="nonotif">'.(in_blacklist($user['id'], $id) ? 'Удалить из ЧС' : 'Добавить в ЧС').'</a></div>';

    }

    if ($adm_id == 1 || $adm_id == 5) {

        // prepared
        $del_mail = $connect->prepare("delete from `mail` where `from` = :uid or `to` = :uid");
        $del_contact = $connect->prepare("delete from `contacts` where `from` = :uid or `to` = :uid");
        $del_chat = $connect->prepare("delete from `guest` where `uid` = ?");
        $del_comments = $connect->prepare("delete from `comments` where `uid` = ?");

        echo '<div class="title">Управление</div>';

        if (isset($_GET['edit']) && $adm_id == 1) {
            if (isset($_POST['cancel'])) {
                header('Location: /user/'.$id);
            }
            elseif (isset($_POST['red'])) {
                $error = '';
                if (empty($_POST['login'])) {
                    $error.= 'Введите логин!<br/>';
                }
                elseif (mb_strlen($_POST['login']) < 3 || mb_strlen($_POST['login']) > 15) {
                    $error.= 'Логин должен содержать от 3 до 15 символов!<br/>';
                }
                elseif (!preg_match("#^[a-z0-9_-]{1,15}$#i", $_POST['login'])) {
                    $error.= 'Логин должен состоять из латинских букв и/или цифр!<br />';
                }
                elseif ($_POST['login'] != $row['login'] && user($_POST['login'], 1)) {
                    $error.= 'Этот логин занят!<br/>';
                }
                if (!is_numeric($_POST['money'])) {
                    $error.= 'Баланс заполнен неверно!<br/>';
                }
                if (!is_numeric($_POST['rating'])) {
                    $error.= 'Рейтинг заполнен неверно!<br/>';
                }
                if (empty($_POST['email'])) {
                    $error.= 'Поле e-mail обязательно для заполнения!<br/>';
                }
                elseif (!filter_var($_POST['email'], FILTER_VALIDATE_EMAIL)) {
                    $error.= 'Поле e-mail заполнено неверно!<br/>';
                }
                elseif ($_POST['wmid'] != NULL && !preg_match("#^[0-9]{12}$#i", $_POST['wmid'])) {
                    $error.= 'Неверно введен WMID: вводить нужно 12 цифр!<br/>';
                }
                elseif ($_POST['wmr'] != NULL && !preg_match("#^R[0-9]{12}$#i", $_POST['wmr'])) {
                    $error.= 'Неверно введен WMR-кошелек: вводить нужно, начиная с R!<br/>';
                }
                if ($error) {
                    echo '<div class="menu">'.$error.'</div>';
                } else {
                    $stmt = $connect->prepare("update `users` set `login` = ?, `money` = ?, `rating` = ?, `wmid` = ?, `wmr` = ?, `email` = ? where `id` = ?");
                    if ($stmt->execute(array($_POST['login'], $_POST['money'], $_POST['rating'], $_POST['wmid'], $_POST['wmr'], $_POST['email'], $id))) {
                        header('Location: /user/'.$id);
                    } else {
                        echo '<div class="menu">Произошла ошибка!</div>';
                    }
                }
            }
            echo '<div class="menu">
            <form action="" method="POST">
            Логин:<br/><input type="text" name="login" value="'.$row['login'].'"><br/>
            Баланс:<br/><input type="text" name="money" value="'.$row['money'].'"><br/>
            Рейтинг:<br/><input type="text" name="rating" value="'.$row['rating'].'"><br/>
            E-mail:<br/><input type="email" name="email" value="'.$row['email'].'"><br/>
            WMID:<br/><input type="text" name="wmid" value="'.$row['wmid'].'"><br/> 
            R-кошелек:<br/><input type="text" name="wmr" value="'.$row['wmr'].'"><br/> 
            <input type="submit" name="red" value="Сохранить">
            <input type="submit" name="cancel" value="Отмена">
            </form></div>';
        }
        elseif (isset($_GET['adm']) && $id != $user['id'] && $adm_id == 1) {
            if (isset($_POST['cancel'])) {
                header('Location: /user/'.$id);
            }
            elseif (isset($_POST['ok'])) {
                $error = '';
                if (!isset($levels[$_POST['status']])) {
                    $error.= 'Данного уровня пользователя нет!<br/>';
                }
                if ($error) {
                    echo '<div class="menu">'.$error.'</div>';
                } else {
                    $stmt = $connect->prepare("update `users` set `admin` = ?, `adm_pos` = ? where `id` = ?");
                    if ($stmt->execute(array($_POST['status'], ($_POST['status'] != 0 ? $_POST['adm_pos'] : ''), $id))) {
                        header('Location: /user/'.$id);
                    } else {
                        echo '<div class="menu">Произошла ошибка!</div>';
                    }
                }
            }

            echo '<div class="menu">
            <form action="" method="POST">
            Должность:<br/><input type="text" name="adm_pos" value="'.$row['adm_pos'].'"><br/>
            Уровень:<br/><select name="status">';

            foreach ($levels as $key => $value) {

                echo '<option ' . ($row['admin'] == $key ? 'selected' : '') . ' value="'.$key.'">'.$value.'</option>'; 

            }

            echo '</select><br/> 
            <input type="submit" name="ok" value="Назначить">
            <input type="submit" name="cancel" value="Отмена">
            </form></div>';
        } 
        elseif (isset($_GET['ban']) && $id != $user['id'] && $row['admin'] == 0) {
            $ban = $connect->prepare("update `users` set `ban` = ? where `id` = ?"); 
            if ($row['ban'] > time()) {
                if (isset($_POST['cancel'])) {
                    header('Location: /user/'.$id);
                }
                elseif (isset($_POST['ok'])) {
                    if ($ban->execute(array(0, $id))) {
                        header('Location: /user/'.$id);
                    } else {
                        echo '<div class="menu">Произошла ошибка!</div>';
                    }
                } 
                echo '<div class="menu">
                <form action="" method="POST">
                <input type="submit" name="ok" value="Разблокировать аккаунт">
                <input type="submit" name="cancel" value="Отмена">
                </form></div>';
            } else {
                if (isset($_POST['cancel'])) {
                    header('Location: /user/'.$id);
                }
                elseif (isset($_POST['ok'])) {
                    $error = '';
                    if (empty($_POST['hours'])) {
                        $error.= 'Введите количество часов!<br/>';
                    } 
                    if ($error) {
                        echo '<div class="menu">'.$error.'</div>';
                    } else {
                        $hours = intval(abs($_POST['hours']));
                        $time = time() + 3600 * $hours;
                        if ($ban->execute(array($time, $id))) {
                            header('Location: /user/'.$id);
                        } else {
                            echo '<div class="menu">Произошла ошибка!</div>';
                        }
                    }
                }
                echo '<div class="menu">
                <form action="" method="POST">
                Количество часов:<br/><input type="text" name="hours"><br/>
                <input type="submit" name="ok" value="Заблокировать аккаунт">
                <input type="submit" name="cancel" value="Отмена">
                </form></div>';
            }
        }
        elseif (isset($_GET['del']) && $id != $user['id'] && $adm_id == 1) {
            if (isset($_POST['cancel'])) {
                header('Location: /user/'.$id);
            } 
            elseif (isset($_POST['yes'])) {

                // Удаляем юзера
                $del = $connect->prepare("delete from `users` where `id` = ?");
                // Удаляем друзей
                $del_friend = $connect->prepare("delete from `friend` where `from` = :uid or `to` = :uid");
                // Чистим логи авторизаций
                $del_authlog = $connect->prepare("delete from `authlog` where `uid` = ?");
                // Чистим плюсы/минусы
                $del_respect = $connect->prepare("delete from `respect` where `to` = ?");

                if ($del->execute(array($id)) &&
                    $del_mail->execute(array(':uid' => $id)) &&
                    $del_friend->execute(array(':uid' => $id)) &&
                    $del_contact->execute(array(':uid' => $id)) &&
                    $del_authlog->execute(array($id)) &&
                    $del_respect->execute(array($row['login']))) {

                    if ($avatar)
                        unlink($avatar);

                    if ($icon)
                        unlink($icon);

                    header('Location: /');

                } else {
                    echo '<div class="menu">Произошла ошибка!</div>';
                }
            }

            echo '<div class="menu">
            <form action="" method="POST">
            <input type="submit" name="yes" value="Удалить аккаунт"/> 
            <input type="submit" name="cancel" value="Отмена"/>
            </form></div>';

        }
        elseif (isset($_GET['chatlog']) && $row['admin'] == 0) {
            if (isset($_POST['cancel'])) {
                header('Location: /user/'.$id);
            } 
            elseif (isset($_POST['yes'])) {
                if ($del_mail->execute(array(':uid' => $id)) &&
                    $del_contact->execute(array(':uid' => $id)) &&
                    $del_chat->execute(array($id)) &&
                    $del_comments->execute(array($id))) {

                    header('Location: /user/'.$id);

                } else {
                    echo '<div class="menu">Произошла ошибка!</div>';
                }
            }

            echo '<div class="menu">
            <form action="" method="POST">
            <input type="submit" name="yes" value="Очистить историю сообщений"/> 
            <input type="submit" name="cancel" value="Отмена"/>
            </form></div>';

        }

        echo '<div class="menu">
        Баланс: '.quantDec($row['money'], ['рубль', 'рубля', 'рублей']).'<br/>
        WMID: '.(empty($row['wmid']) ? 'Не заполнен' : 
            '<a href="http://passport.webmoney.ru/asp/certview.asp?wmid='.$row['wmid'].'">'.$row['wmid'].'</a><br/>
             BL: <img src="https://bl.wmtransfer.com/img/bl/'.$row['wmid'].'?w=45&h=18&bg=0XDBE2E9.png" alt="bl"><br/>
             Претензии/Отзывы/Иски: <a href="http://arbitrage.webmoney.ru/asp/claims.asp?wmid='.$row['wmid'].'"><img src="http://arbitrage.webmoney.ru/xml/AL2.aspx?wmid='.$row['wmid'].'" alt="arb"></a>'
        ).'<br/>
        Кошелек: '.(empty($row['wmr']) ? 'Не заполнен' : '<img src="/img/wmr.png" alt="wmr">'.$row['wmr']).'<br/>
        E-mail: '.$row['email'].'<br/>
        '.($auth ? 'IP: <a href="/adm/ip?ip='.$auth['ip'].'">'.$auth['ip'].'</a><br/>
        UA: '.$auth['ua'].'<br/>' : '').'
        Временная зона: '.($row['timezone'] ? $row['timezone'] : 'DEFAULT').'
        <div class="butt2">
        '.($adm_id == 1 ? ($id != $user['id'] ? '<a href="?del">Удалить</a>
        <a href="?adm">Должность</a>' : '').'
        <a href="?edit">Редактировать</a><br/>' : '').
        ($id != $user['id'] && $row['admin'] == 0 ? '<a href="?ban">'.($row['ban'] > time() ? 'Разблокировать аккаунт' : 'Заблокировать аккаунт').'</a>' : '').
        ($row['admin'] == 0 ? '<a href="?chatlog">Очистить историю сообщений</a>' : '').'
        </div>
        </div>';

        /* Логи входов */

        $stmt_auth->execute(array($id));
        $count_auth = $stmt_auth->fetchColumn();

        echo '<div class="title">История авторизаций ('.$count_auth.')</div>';

        if ($count_auth == 0) {
            echo '<div class="menu">Записей нет!</div>';
        } else {

            $page = new Pagination($count_auth, 5);

            $data = $connect->prepare("select * from `authlog` where `uid` = :uid order by `id` desc limit :start, 5");
            $data->bindValue(':uid', $id, PDO::PARAM_INT);
            $data->bindValue(':start', $page->start, PDO::PARAM_INT);
            $data->execute();
            $sql = $data->fetchAll();

            foreach ($sql as $row) {
                echo '<div class="menu">
                Время: '.date('d.m.Y H:i', $row['time']).'<br/>
                Последнее посещение: '.date('d.m.Y H:i', $row['lasttime']).deviceIcon($row['ua']).'<br/>
                IP: <a href="/adm/ip?ip='.$row['ip'].'">'.$row['ip'].'</a><br/>
                UA: '.$row['ua'].
                ($row['status'] == 0 ? '<div class="forbidden">Авторизация сброшена!</div>' : '').'
                </div>';
            }

            $page->navigation();

        }

    }

} else {
    header('Location: /');
}

require($_SERVER["DOCUMENT_ROOT"]."/inc/foot.php");
?>